profunctors-5.1.2: Profunctors

Copyright | (C) 2015 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | MPTCs, fundeps
Safe Haskell | Safe
Language | Haskell2010

Data.Profunctor.Sieve

Description

Synopsis

- class (Profunctor p, Functor f) => Sieve p f | p -> f where
  - sieve :: p a b -> a -> f b
- class (Profunctor p, Functor f) => Cosieve p f | p -> f where
  - cosieve :: p a b -> f a -> b

# Documentation

class (Profunctor p, Functor f) => Sieve p f | p -> f where Source

A `Profunctor` `p` is a `Sieve` on `f` if it is a subprofunctor of ``Star` f`.

That is to say it is a subset of `Hom(-,f=)` closed under `lmap` and `rmap`.

Alternately, you can view it as a sieve in the comma category `Hask/f`.

Methods

sieve :: p a b -> a -> f b Source

Instances

Sieve (->) Identity Source |
(Monad m, Functor m) => Sieve (Kleisli m) m Source |
Functor f => Sieve (Star f) f Source |
Sieve (Forget r) (Const r) Source |
(Sieve p f, Sieve q g) => Sieve (Procompose p q) (Compose g f) Source |

class (Profunctor p, Functor f) => Cosieve p f | p -> f where Source

A `Profunctor` `p` is a `Cosieve` on `f` if it is a subprofunctor of ``Costar` f`.

That is to say it is a subset of `Hom(f-,=)` closed under `lmap` and `rmap`.

Alternately, you can view it as a cosieve in the comma category `f/Hask`.

Methods

cosieve :: p a b -> f a -> b Source

Instances

Cosieve (->) Identity Source |
Functor w => Cosieve (Cokleisli w) w Source |
Functor f => Cosieve (Costar f) f Source |
Cosieve (Tagged *) (Proxy *) Source |
(Cosieve p f, Cosieve q g) => Cosieve (Procompose p q) (Compose f g) Source |